-- Celestia add-on "seasons"
-- Version 2017-08-25
-- Author: catwrings @ Celestia Forum https://celestiaproject.net/forum/

require "locale";
require "CXClass";
require "CXBox";
require "seasons_config";

local width, height = celestia:getscreendimension();
local obs = celestia:getobserver();

local get_season = function()
   local season_time = obs:gettime()
   local season_time = celestia:tdbtoutc(season_time)
   local season_time_m = season_time.month
   surf_name = string.format("month-%02d", season_time_m)
   obs:setsurface(surf_name)
end

seasonsBox = CXBox:new()
	:init(0, 0, 0, 0)
	:textfont(normalfont)
	:textcolor(ctext)
	:textpos("left")
	:movetext(20, 5)
	:text(_("Seasons"))
	:movable(false)
	:attach(screenBox, width, height, 0, 0);

seasonsFrame = CXBox:new()
	:init(0, 0, 0, 0)
	:movable(false)
	:visible(false)
	:active(false)
	:attach(screenBox, 0, 0, 0, 0);

seasonsFrame.Customdraw = function(this)
	get_season()
end

seasonsCheck = CXBox:new()
	:init(0, 0, 0, 0)
	:bordercolor(cbubordoff)
	--:fillcolor({1,1,0,.2})
	:textfont(smallfont)
	:textcolor(cbutextoff)
	:textpos("center")
	:movetext(0, 10)
	:text("")
	:movable(false)
	:active(true)
	:attach(seasonsBox, boxWidth - 40, 4, 29, 5);

-- display_seasons is defined in seasons_config
-- if it is not defined, counts as false
if display_seasons then
	seasonsFrame.Visible = true;
	seasonsCheck.Text = "x";
end

seasonsCheck.Action = (function()
	return
	function()
		display_seasons = not display_seasons;
		if display_seasons then
			seasonsFrame.Visible = true;
			seasonsCheck.Text = "x";
		else
			seasonsFrame.Visible = false;
			obs:setsurface("")
			seasonsCheck.Text = "";
		end
	end
end) ();
